### Summary

This PR adds a new module for **CleverCloud**. It enables the injection of the following nodes into Cartography:
- CleverCloudOrganization
- CleverCloudApplication
- CleverCloudAddon


### Related issues or links
> Include links to relevant issues or other pages.


### Checklist
- [ ] Correct all the CHANGEME in code generated by [cartography-openapi](https://github.com/jychp/cartography-openapi)
- [ ] Add the necessary configuration keys in `cartography/config.py`
    - [ ] Add parameters for authentication
    - [ ] Add `clevercloud_id` parameter
- [ ] Add the required parameters in `cartography/cli.py`
- [ ] Import the module in `cartography/sync.py`
- [ ] Update the cartography `README.md`
- [ ] Update the schema documentation `docs/root/usage/schema.md`
- [ ] Include a screenshot showing what the graph looked like before and after your changes.
- [ ] Include console log trace showing what happened before and after your changes.