### Summary

This PR adds a new module for **Keycloak**. It enables the injection of the following nodes into Cartography:
- KeycloakRealm
- KeycloakClient
- KeycloakGroup
- KeycloakUser


### Related issues or links
> Include links to relevant issues or other pages.


### Checklist
- [ ] No servers found in the OpenAPI spec,edit the `intel/*.py` files to add the server URL.
- [ ] Correct all the CHANGEME in code generated by [cartography-openapi](https://github.com/jychp/cartography-openapi)
- [ ] Add the necessary configuration keys in `cartography/config.py`
    - [ ] Add parameters for authentication
    - [ ] Add `keycloak_realm` parameter
- [ ] Add the required parameters in `cartography/cli.py`
- [ ] Import the module in `cartography/sync.py`
- [ ] Update the cartography `README.md`
- [ ] Update the schema documentation `docs/root/usage/schema.md`
- [ ] Include a screenshot showing what the graph looked like before and after your changes.
- [ ] Include console log trace showing what happened before and after your changes.